/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.eventing;

import org.apache.ws.addressing.EndpointReference;
import org.apache.ws.pubsub.NotificationConsumer;
import org.apache.ws.pubsub.NotificationProducer;
import org.apache.ws.pubsub.SubscriptionEndConsumer;
import org.apache.ws.resource.ResourceHome;
import org.apache.ws.resource.lifetime.ResourceTerminationListener;
import java.util.Calendar;

/**
 * DOCUMENT_ME
 *
 * @version $Revision: 1.8 $
 * @author $author$
 */
public abstract class AbstractSubscription
   implements org.apache.ws.pubsub.Subscription,
              org.apache.ws.resource.Resource
{
   /** DOCUMENT_ME */
   protected NotificationConsumer consumer;

   /** DOCUMENT_ME */
   protected SubscriptionEndConsumer endconsumer;

   /** DOCUMENT_ME */
   protected String m_id;

   /** DOCUMENT_ME */
   protected Calendar m_terminationTime;

   /** DOCUMENT_ME */
   protected Calendar m_creationTime;

   /** DOCUMENT_ME */
   protected ResourceHome rH;

   /** DOCUMENT_ME */
   protected boolean m_usenotify;

   /** The EndpointReference for this resource **/
   protected EndpointReference m_endpointReference;

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public java.util.Calendar getCreationTime(  )
   {
      return m_creationTime;
   }

   /**
    * Sets the EndpointReference associated with this Resource.
    *
    * @param epr The EndpointReference for the Resource.
    */
   public void setEndpointReference( org.apache.ws.addressing.EndpointReference epr )
   {
      m_endpointReference = epr;
   }

   /**
    * Returns the EndpointReference associated with this Resource.
    *
    * @return The Resource's EndpointReference or null if the EndpointReference has not been set.
    *
    * Note: It is the responsibility of the Resource creator to set the EndpointReference (i.e. ResourceHome impl)
    */
   public org.apache.ws.addressing.EndpointReference getEndpointReference(  )
   {
      return m_endpointReference;
   }

   /**
    * DOCUMENT_ME
    *
    * @param epr DOCUMENT_ME
    */
   public void setEpr( EndpointReference epr )
   {
      this.m_endpointReference = epr;
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public org.apache.ws.pubsub.Filter getFilters(  )
   {
      return null;
   }

   /**
    * DOCUMENT_ME
    *
    * @param id DOCUMENT_ME
    */
   public void setID( Object id )
   {
      this.m_id = (String) id;
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public Object getID(  )
   {
      return this.m_id;
   }

   /**
    * DOCUMENT_ME
    *
    * @param consumer DOCUMENT_ME
    */
   public void setNotificationConsumer( NotificationConsumer consumer )
   {
      this.consumer = consumer;
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public NotificationConsumer getNotificationConsumer(  )
   {
      return this.consumer;
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public NotificationProducer getNotificationProducer(  )
   {
      return null;
   }

   /**
    * DOCUMENT_ME
    *
    * @param rH DOCUMENT_ME
    */
   public void setResourceHome( ResourceHome rH )
   {
      this.rH = rH;
   }

   /**
    * DOCUMENT_ME
    *
    * @param endconsumer DOCUMENT_ME
    */
   public void setSubscriptionEndConsumer( SubscriptionEndConsumer endconsumer )
   {
      this.endconsumer = endconsumer;
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public SubscriptionEndConsumer getSubscriptionEndConsumer(  )
   {
      return this.endconsumer;
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public java.util.Calendar getTerminationTime(  )
   {
      return m_terminationTime;
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public boolean getUseNotify(  )
   {
      return m_usenotify;
   }

   /**
    * DOCUMENT_ME
    *
    * @param resourceTerminationListener DOCUMENT_ME
    */
   public void addTerminationListener( ResourceTerminationListener resourceTerminationListener )
   {
      //this is a no op  todo Stefan I need to know if you want to leverege this
   }
}