/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.eventing.porttype.impl;

import org.apache.axis.message.SOAPEnvelope;
import org.apache.axis.utils.XMLUtils;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.ws.eventing.pubsub.Subscription;
import org.apache.ws.resource.NamespaceVersionHolder;
import org.apache.ws.resource.ResourceContext;
import org.apache.ws.resource.properties.impl.AbstractResourcePropertiesPortType;

/**
 * Impl of WS-Eventing Notification portType.
 *
 * @version $Revision: 1.8 $
 * @author $author$
 */
public class NotificationPortTypeImpl
   extends AbstractResourcePropertiesPortType
   implements org.apache.ws.eventing.porttype.NotificationPortType
{
   private static final Log LOG = LogFactory.getLog( NotificationPortTypeImpl.class.getName(  ) );

   /**
    * Creates a new {@link NotificationPortTypeImpl} object.
    *
    * @param resourceContext DOCUMENT_ME
    */
   public NotificationPortTypeImpl( ResourceContext resourceContext )
   {
      super( resourceContext );
   }

   //TODO maybe remove Axis dep
   //TODO use WSRF Provider with Message styler
   public void filter( SOAPEnvelope req,
                       SOAPEnvelope resp )
   {
      try
      {
         String       xml = XMLUtils.ElementToString( req.getBody(  ) );

         Subscription subscription = (Subscription) getResource(  );
         LOG.info( "notification for subscription : " + subscription.getID(  ) );
         subscription.getNotificationConsumer(  ).notify( subscription, xml );
      }
      catch ( Exception e )
      {
         //TODO
         e.printStackTrace(  );
      }
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   protected NamespaceVersionHolder getNamespaceSet(  )
   {
      return null; // not currently used - will be needed once we need to support multiple spec versions
   }
}