/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.notification.base.v2004_06.porttype;

import org.apache.ws.notification.base.v2004_06.BaseNotificationConstants;
import org.oasisOpen.docs.wsn.x2004.x06.wsnWSBaseNotification12Draft01.NotifyDocument;
import javax.xml.namespace.QName;

/**
 * The WS-BaseNotification NotificationConsumer portType.
 */
public interface NotificationConsumerPortType
{
   /**
    * QName of the NotificationConsumer
    */
   QName NAME =
      new QName( BaseNotificationConstants.NSURI_WSNT_WSDL.toString(  ), "NotificationConsumer",
                 BaseNotificationConstants.NSPREFIX_WSNT_WSDL );

   /**
    * Method for receiving notifications.
    *
    * @param requestDoc
    */
   void notify( NotifyDocument requestDoc );
}