/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.notification.pubsub;

import org.apache.ws.pubsub.emitter.EmitterTask;
import javax.xml.soap.SOAPMessage;

/**
 *
 * @author  Stefan Lischke
 */
public class Publisher
   implements org.apache.ws.pubsub.Publisher
{
   private String m_url;

   /**
    * Creates a new {@link Publisher} object.
    *
    * @param url DOCUMENT_ME
    */
   public Publisher( String url )
   {
      m_url = url;
   }

   /**
    * DOCUMENT_ME
    *
    * @param msg DOCUMENT_ME
    * @param t DOCUMENT_ME
    */
   public void publish( Object                                  msg,
                        org.apache.ws.notification.topics.Topic t )
   {
   }

   private void publish( SOAPMessage soapMsg )
   throws Exception
   {
      EmitterTask et = EmitterTask.createEmitterTask( soapMsg,
                                                      new java.net.URL( m_url ) );
      et.run(  );
   }
}