/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.notification.pubsub;

import org.apache.ws.addressing.EndpointReference;
import org.apache.ws.addressing.XmlBeansEndpointReference;
import org.apache.ws.notification.base.impl.AbstractSubscription;
import org.apache.ws.notification.topics.expression.TopicExpression;
import org.apache.ws.pubsub.SubscriptionEndConsumer;
import org.apache.ws.resource.NamespaceVersionHolder;
import org.oasisOpen.docs.wsn.x2004.x06.wsnWSBaseNotification12Draft01.SubscribeResponseDocument;

/**
 *
 * @author  Stefan Lischke
 */
public class Subscription
   extends AbstractSubscription
{
   /**
    * Creates a new {@link Subscription} object.
    *
    * @param producerRef DOCUMENT_ME
    * @param consumerRef DOCUMENT_ME
    * @param topicExpr DOCUMENT_ME
    */
   public Subscription( EndpointReference producerRef,
                        EndpointReference consumerRef,
                        TopicExpression   topicExpr )
   {
      super( producerRef, consumerRef, topicExpr );
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public NamespaceVersionHolder getNamespaceSet(  )
   {
      return null; // TODO
   }

   /**
    * DOCUMENT_ME
    *
    * @param propSet DOCUMENT_ME
    */
   public void setResourcePropertySet( org.apache.ws.resource.properties.ResourcePropertySet propSet )
   {
   }

   /**
    * Get the subscriptionEnd consumer associated with this subscription.
    *
    * @return the subscriptionEnd consumer
    */
   public SubscriptionEndConsumer getSubscriptionEndConsumer(  )
   {
      return null; //todo
   }

   /**
    * DOCUMENT_ME
    *
    * @param sresdom DOCUMENT_ME
    */
   public void setSubscriptionManager( SubscribeResponseDocument.SubscribeResponse sresdom )
   {
      super.setEndpointReference( new XmlBeansEndpointReference( sresdom.getSubscriptionReference(  ) ) );
   }

   /**
    * DOCUMENT_ME
    */
   public void init(  )
   {
   }
}