/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.notification.tool.v2004_06;

import org.apache.ws.notification.base.NotificationProducerResource;
import org.apache.ws.notification.base.v2004_06.porttype.NotificationProducerPortType;
import org.apache.ws.resource.tool.PortType2JavaInfo;
import javax.xml.namespace.QName;

/**
 * A PortType2Java impl for the NotificationProducer portType which tells WsnWsdl2Java
 * information on how to implement this portType in the generated code.
 *
 * @author Ian Springer (ian DOT springer AT hp DOT com)
 */
public class NotificationProducerPortType2JavaInfo
   extends PortType2JavaInfo
{
   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public String getAbstractResourceInitMethodIncludeLocation(  )
   {
      return "templates/NotificationProducer-AbstractResource_init.txt";
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public QName getName(  )
   {
      return NotificationProducerPortType.NAME;
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public String getResourceInitMethodIncludeLocation(  )
   {
      return "templates/NotificationProducer-Resource_init.txt";
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public String getResourceInterfaceName(  )
   {
      return NotificationProducerResource.class.getName(  );
   }

   /**
    * @see org.apache.ws.resource.tool.PortType2JavaInfo#getResourceTemplateFileName()
    */
   public String getResourceTemplateFileName(  )
   {
      return "templates/NotificationProducerResource.txt";
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public String getServiceInterfaceName(  )
   {
      return NotificationProducerPortType.class.getName(  );
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public String getServiceTemplateFileName(  )
   {
      return "templates/v2004_06/NotificationProducerPortType.txt";
   }
}