/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.notification.topics;

import org.apache.ws.UnsupportedNamespaceException;
import org.apache.ws.notification.topics.expression.InvalidTopicExpressionException;
import org.apache.ws.notification.topics.expression.TopicExpression;
import org.apache.ws.notification.topics.v2004_06.TopicsConstants;
import org.apache.ws.notification.topics.v2004_06.TopicsTypeReaderImpl;
import org.apache.xmlbeans.XmlObject;

/**
 * TODO
 */
public abstract class TopicsTypeReader
{
   /**
    * DOCUMENT_ME
    *
    * @param schemaNamespace DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    *
    * @throws UnsupportedNamespaceException DOCUMENT_ME
    */
   public static TopicsTypeReader newInstance( String schemaNamespace )
   throws UnsupportedNamespaceException
   {
      if ( schemaNamespace.equals( TopicsConstants.NSURI_WSTOP_SCHEMA ) )
      {
         return new TopicsTypeReaderImpl(  );
      }
      else
      {
         throw new UnsupportedNamespaceException( schemaNamespace
                                                  + " is not the namespace of a supported version of the WS-Topics schema." );
      }
   }

   /**
    * DOCUMENT_ME
    *
    * @param xBean DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    *
    * @throws InvalidTopicExpressionException DOCUMENT_ME
    */
   public abstract TopicExpression toTopicExpression( XmlObject xBean )
   throws InvalidTopicExpressionException;

   /**
    * DOCUMENT_ME
    *
    * @param xBean DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public abstract TopicNamespace toTopicNamespace( XmlObject xBean );
}