/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.notification.topics.expression;


/**
 * This exception is raised when resolution of a topic expression fails.
 */
public class TopicExpressionResolutionException
   extends org.apache.ws.notification.topics.expression.TopicExpressionException
{
   /**
    * Creates a TopicExpressionResolutionException without error message.
    */
   public TopicExpressionResolutionException(  )
   {
   }

   /**
    * Creates a TopicExpressionResolutionException with a given error message.
    *
    * @param message error message
    */
   public TopicExpressionResolutionException( String message )
   {
      super( message );
   }

   /**
    * Creates a TopicExpressionResolutionException with a given error message
    * and nested exception.
    *
    * @param message   error message
    * @param exception nested exception
    */
   public TopicExpressionResolutionException( String    message,
                                              Throwable exception )
   {
      super( message, exception );
   }

   /**
    * Creates a TopicExpressionResolutionException from a nested exception.
    *
    * @param exception nested exception
    */
   public TopicExpressionResolutionException( Throwable exception )
   {
      super( exception );
   }
}