/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.notification.topics.expression.impl;

import org.apache.ws.notification.topics.expression.TopicExpression;

/**
 * An abstract implementation of <code>TopicExpression</code> that can be extended by dialect-specific implementations.
 *
 * @author Ian Springer
 */
public abstract class AbstractTopicExpression
   implements TopicExpression
{
   private transient String m_dialect;
   private transient Object m_content;

   /**
    * Creates a new {@link AbstractTopicExpression} object.
    *
    * @param dialect DOCUMENT_ME
    * @param content DOCUMENT_ME
    */
   public AbstractTopicExpression( String dialect,
                                   Object content )
   {
      m_dialect    = dialect;
      m_content    = content;
   }

   /**
    * Creates a new {@link AbstractTopicExpression} object.
    */
   protected AbstractTopicExpression(  )
   {
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public Object getContent(  )
   {
      return m_content;
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public String getDialect(  )
   {
      return m_dialect;
   }

   /**
    * @return
    */
   public int hashCode(  )
   {
      return toString(  ).hashCode(  );
   }

   /**
    * DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public String toString(  )
   {
      return m_content.toString(  );
   }

   /**
    * DOCUMENT_ME
    *
    * @param content DOCUMENT_ME
    */
   protected void setContent( Object content )
   {
      m_content = content;
   }

   /**
    * DOCUMENT_ME
    *
    * @param dialect DOCUMENT_ME
    */
   protected void setDialect( String dialect )
   {
      m_dialect = dialect;
   }
}