/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.notification.topics.v2004_06;


/**
 * Constants defined by the WS-Topics 1.2 Draft 01 specification.
 */
public interface TopicsConstants
{
   /**
    * Namespace URI of the WS-Topics 1.2 Draft 01 schema.
    */
   String NSURI_WSTOP_SCHEMA = "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-Topics-1.2-draft-01.xsd";

   /**
    * Namespace prefix for the WS-Topics 1.2 Draft 01 schema.
    */
   String NSPREFIX_WSTOP_SCHEMA = "wstop";

   /**
    * URI of the "Simple" topic expression dialect.
    */
   String TOPIC_EXPR_DIALECT_SIMPLE = "http://docs.oasis-open.org/wsn/2004/06/TopicExpression/Simple";

   /**
    * URI of the "Concrete" topic expression dialect.
    */
   String TOPIC_EXPR_DIALECT_CONCRETE = "http://docs.oasis-open.org/wsn/2004/06/TopicExpression/Concrete";

   /**
    * URI of the "Full" topic expression dialect.
    */
   String TOPIC_EXPR_DIALECT_FULL = "http://docs.oasis-open.org/wsn/2004/06/TopicExpression/Full";
}