/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.notification.topics.v2004_06;

import org.apache.ws.notification.base.v2004_06.porttype.NotificationProducerPortType;
import org.apache.ws.notification.topics.TopicNamespace;
import org.apache.ws.notification.topics.TopicsTypeWriter;
import org.apache.ws.notification.topics.expression.TopicExpression;
import org.apache.xmlbeans.XmlObject;
import org.oasisOpen.docs.wsn.x2004.x06.wsnWSBaseNotification12Draft01.TopicDocument;
import org.oasisOpen.docs.wsn.x2004.x06.wsnWSBaseNotification12Draft01.TopicExpressionDocument;
import org.oasisOpen.docs.wsn.x2004.x06.wsnWSBaseNotification12Draft01.TopicExpressionType;
import org.oasisOpen.docs.wsn.x2004.x06.wsnWSTopics12Draft01.TopicSpaceDocument;
import org.oasisOpen.docs.wsn.x2004.x06.wsnWSTopics12Draft01.TopicSpaceType;
import javax.xml.namespace.QName;

/**
 * A topics type writer for the 2004/06 version of the WS-Topics specification.
 */
public class TopicsTypeWriterImpl
   extends TopicsTypeWriter
{
   /**
    * DOCUMENT_ME
    *
    * @param topicExpr DOCUMENT_ME
    * @param elemName DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public XmlObject toXmlObject( TopicExpression topicExpr,
                                 QName           elemName )
   {
      TopicExpressionType topicExprType;
      if ( elemName.equals( NotificationProducerPortType.PROP_QNAME_TOPIC ) )
      {
         TopicDocument topicDoc = TopicDocument.Factory.newInstance(  );
         topicExprType = topicDoc.addNewTopic(  );
      }
      else
      {
         TopicExpressionDocument topicExprDoc = TopicExpressionDocument.Factory.newInstance(  );
         topicExprType = topicExprDoc.addNewTopicExpression(  );
      }

      topicExprType.setDialect( topicExpr.getDialect(  ).toString(  ) );
      copyContent( topicExpr, topicExprType );
      return topicExprType;
   }

   /**
    * DOCUMENT_ME
    *
    * @param topicNs DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    */
   public XmlObject toXmlObject( TopicNamespace topicNs )
   {
      TopicSpaceDocument topicSpaceDoc  = TopicSpaceDocument.Factory.newInstance(  );
      TopicSpaceType     topicSpaceType = topicSpaceDoc.addNewTopicSpace(  );

      // TODO: finish this
      return topicSpaceType;
   }
}