/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.pubsub;


/**
 *
 * @author  Stefan Lischke
 */
public class XPathFilter
   extends AbstractFilter
   implements Filter
{
   /**
    * Creates a new {@link XPathFilter} object.
    *
    * @param filter DOCUMENT_ME
    */
   public XPathFilter( String filter )
   {
      this( filter, FilterFactory.xpathuri );
   }

   /**
    * Creates a new {@link XPathFilter} object.
    *
    * @param filter DOCUMENT_ME
    * @param dialect DOCUMENT_ME
    */
   public XPathFilter( String filter,
                       String dialect )
   {
      //TODO test pathexepr type
      //TODO create node
      javax.xml.parsers.DocumentBuilderFactory dbf = javax.xml.parsers.DocumentBuilderFactory.newInstance(  );
      try
      {
         javax.xml.parsers.DocumentBuilder db = dbf.newDocumentBuilder(  );

         org.w3c.dom.Document              dom = db.newDocument(  );
         super.setContent( dom.createTextNode( filter ) );
         super.setURI( FilterFactory.xpathuri );
      }
      catch ( javax.xml.parsers.ParserConfigurationException e )
      {
         //TODO
         e.printStackTrace(  );
      }

      super.setURI( dialect );
   }
}