/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.pubsub.i18n;


/**
 * i18n message keys for the <code>org.apache.ws.notification</code> package.
 */
public interface Keys
{
   /** DOCUMENT_ME */
   String CREATE_SUB_TABLE = "CREATE_SUB_TABLE";

   /** DOCUMENT_ME */
   String CREATING_SUB_TABLE_MGR = "CREATING_SUB_TABLE_MGR";

   /** DOCUMENT_ME */
   String EMITTING_MESSAGE = "EMITTING_MESSAGE";

   /** DOCUMENT_ME */
   String INVALID_SUBMGR_TABLE_TYPE = "INVALID_SUBMGR_TABLE_TYPE";

   /** DOCUMENT_ME */
   String MESSAGE_NOT_AVAILABLE_FOR_TOPIC = "MESSAGE_NOT_AVAILABLE_FOR_TOPIC";

   /** DOCUMENT_ME */
   String NULL_PROP_QNAME = "NULL_PROP_QNAME";

   /** DOCUMENT_ME */
   String NULL_SUBID_NOT_ALLOWED = "NULL_SUBID_NOT_ALLOWED";

   /** DOCUMENT_ME */
   String TOPIC_NOT_AVAILABLE_FOR_SUBSCRIPTION = "TOPIC_NOT_AVAILABLE_FOR_SUBSCRIPTION";

   /** CREATING_NOTIF_EMITTER=Creating a notification emitter to destination=[{0}] */
   String CREATING_NOTIF_EMITTER = "CREATING_NOTIF_EMITTER";

   /** NOTIF_EMITTER_CREATION_FAILURE=Failed to create a notification emitter for destination [{0}]. Cause: {1} */
   String NOTIF_EMITTER_CREATION_FAILURE = "NOTIF_EMITTER_CREATION_FAILURE";

   /** UNSUPPORTED_PROTOCOL=Destination requires an unsupported protocol [{0}]; it will not receive notification [{1}] */
   String UNSUPPORTED_PROTOCOL = "UNSUPPORTED_PROTOCOL";

   /** BAD_TASK_CLASS_IS_ABSTRACT=Bad task class [{0}]; it must not be abstract. Cause: {1} */
   String BAD_TASK_CLASS_IS_ABSTRACT = "BAD_TASK_CLASS_IS_ABSTRACT";

   /** BAD_TASK_CLASS_ACCESS_DENIED=Bad task class [{0}]; access to the constructor was denied. Cause: {1} */
   String BAD_TASK_CLASS_ACCESS_DENIED = "BAD_TASK_CLASS_ACCESS_DENIED";

   /** TASK_CON_EXCEPTION=Task [{0}] constructor threw an exception: {1} */
   String TASK_CON_EXCEPTION = "TASK_CON_EXCEPTION";

   /** BAD_TASK_CLASS_NO_CON=Bad task class [{0}], missing required constructor. Cause: {1} */
   String BAD_TASK_CLASS_NO_CON = "BAD_TASK_CLASS_NO_CON";

   /** EMITTING_NOTIFICATION=Emitting notification: destination=[{0}], notification=[{1}] */
   String EMITTING_NOTIFICATION = "EMITTING_NOTIFICATION";

   /**
    * @msg SOAP Response to emitted notification: [{0}]
    **/
   String RESPONSE_TO_EMIT = "RESPONSE_TO_EMIT";

   /** EMISSION_FAILURE={0} failed to emit notification [{1}]. Cause: {2} */
   String EMISSION_FAILURE = "EMISSION_FAILURE";

   /** EX_NO_NOTIFICATIONS=No Notifications to emit! */
   String EX_NO_NOTIFICATIONS = "EX_NO_NOTIFICATIONS";

   /** EMITTING_TO_FILE=Emitting notification to file [{0}] */
   String EMITTING_TO_FILE = "EMITTING_TO_FILE";

   /** EX_FAILED_TO_STORE_NOTIFICATION_TO_FILE_BAD_URL=Failed to store notification to file, bad destination URL: [{0}] */
   String EX_FAILED_TO_STORE_NOTIFICATION_TO_FILE_BAD_URL = "EX_FAILED_TO_STORE_NOTIFICATION_TO_FILE_BAD_URL";

   /** EX_FAILED_TO_STORE_NOTIFICATION_TO_FILE=Failed to store notification to file: [{0}] */
   String EX_FAILED_TO_STORE_NOTIFICATION_TO_FILE = "EX_FAILED_TO_STORE_NOTIFICATION_TO_FILE";

   /** EMITTING_TO_HTTP_DEST=Emitting notification to HTTP destination [{0}] */
   String EMITTING_TO_HTTP_DEST = "EMITTING_TO_HTTP_DEST";

   /** EX_FAILED_TO_SEND_HTTP_NOTIFICATION_BAD_URL=Failed to send HTTP notification, bad destination URL: [{0}] */
   String EX_FAILED_TO_SEND_HTTP_NOTIFICATION_BAD_URL = "EX_FAILED_TO_SEND_HTTP_NOTIFICATION_BAD_URL";

   /** EX_FAILED_TO_SEND_HTTP_NOTIFICATION=Failed to send notification via HTTP: [{0}] */
   String EX_FAILED_TO_SEND_HTTP_NOTIFICATION = "EX_FAILED_TO_SEND_HTTP_NOTIFICATION";

   /** GETTING_SUBSCRIBERS=Getting subscribers on topic [{0}] */
   String GETTING_SUBSCRIBERS = "GETTING_SUBSCRIBERS";
}