/*=============================================================================*
 *  Copyright 2004 The Apache Software Foundation
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *=============================================================================*/
package org.apache.ws.pubsub;

import org.apache.ws.addressing.EndpointReference;
import org.apache.xmlbeans.XmlCursor;
import org.apache.xmlbeans.XmlObject;

/**
 *
 * @author  Stefan Lischke
 */
import javax.xml.namespace.QName;
import javax.xml.soap.SOAPConnection;
import javax.xml.soap.SOAPConnectionFactory;
import javax.xml.soap.SOAPException;
import javax.xml.soap.SOAPHeader;
import javax.xml.soap.SOAPMessage;

/**
 * DOCUMENT_ME
 *
 * @version $Revision: 1.8 $
 * @author $author$
 */
public class wsaSOAPConnection
{
   /** Creates a new instance of wsaSOAPConnection */
   public wsaSOAPConnection(  )
   {
   }

   /**
    * @return The unique instance of this class.
    */
   public static wsaSOAPConnection newInstance(  )
   {
      return new wsaSOAPConnection(  );
   }

   /**
    * DOCUMENT_ME
    *
    * @param request DOCUMENT_ME
    * @param url DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    *
    * @throws SOAPException DOCUMENT_ME
    */
   public SOAPMessage call( SOAPMessage request,
                            String      url )
   throws SOAPException
   {
      SOAPConnectionFactory sconF = SOAPConnectionFactory.newInstance(  );
      SOAPConnection        scon = sconF.createConnection(  );
      return ( scon.call( request, url ) );
   }

   /**
    * DOCUMENT_ME
    *
    * @param request DOCUMENT_ME
    * @param epr DOCUMENT_ME
    *
    * @return DOCUMENT_ME
    *
    * @throws SOAPException DOCUMENT_ME
    */
   public SOAPMessage call( SOAPMessage       request,
                            EndpointReference epr )
   throws SOAPException
   {
      SOAPHeader sH = request.getSOAPHeader(  );

      //if epr contains ReferenceProperty add WSA header
      XmlObject[] refprops = (XmlObject[]) epr.getReferenceProperties(  );
      if ( refprops != null )
      {
         for ( int i = 0; i < refprops.length; i++ )
         {
            XmlCursor xc       = refprops[i].newCursor(  );
            QName     propname = xc.getName(  );
            sH.addChildElement( propname.getLocalPart(  ),
                                propname.getPrefix(  ),
                                propname.getNamespaceURI(  ) ).addTextNode( xc.getTextValue(  ) );
            xc.dispose(  );
         }
      }

      return ( call( request,
                     epr.getAddress(  ) ) );
   }
}